Package org.apache.sysds.hops.estim

# Class EstimatorBasicWorst

java.lang.Object
org.apache.sysds.hops.estim.SparsityEstimator
org.apache.sysds.hops.estim.EstimatorBasicWorst

public class EstimatorBasicWorst extends SparsityEstimator
Basic average case estimator for matrix sparsity: sp = Math.min(1, sp1 * k) * Math.min(1, sp2 * k). Note: for outer-products (i.e., k=1) this worst-case estimate is equivalent to the average case estimate and the exact output sparsity.

## Nested Class Summary

## Nested classes/interfaces inherited from class org.apache.sysds.hops.estim.SparsityEstimator

`SparsityEstimator.OpCode`

## Field Summary

### Fields inherited from class org.apache.sysds.hops.estim.SparsityEstimator

`MIN_PAR_THRESHOLD, MULTI_THREADED_BUILD, MULTI_THREADED_ESTIM`

## Constructor Summary

Constructors
Constructor
Description
`EstimatorBasicWorst()`

## Method Summary

Modifier and Type
Method
Description
`DataCharacteristics`
`estim(MMNode root)`
Estimates the output sparsity of a DAG of matrix multiplications for the given operator graph of a single root node.
`double`
`estim(MatrixBlock m, SparsityEstimator.OpCode op)`
Estimates the output sparsity for a given unary operation.
`double`
`estim(MatrixBlock m1, MatrixBlock m2)`
Estimates the output sparsity for a single matrix multiplication.
`double`
`estim(MatrixBlock m1, MatrixBlock m2, SparsityEstimator.OpCode op)`
Estimates the output sparsity for a given binary operation.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### EstimatorBasicWorst

public EstimatorBasicWorst()

## Method Details

### estim

public DataCharacteristics estim(MMNode root)
Description copied from class: `SparsityEstimator`
Estimates the output sparsity of a DAG of matrix multiplications for the given operator graph of a single root node.

Specified by:
  `estim` in class `SparsityEstimator`
Parameters:
  `root` - DAG root node
Returns:
  output data characteristics

### estim

public double estim(MatrixBlock m1, MatrixBlock m2)
Description copied from class: `SparsityEstimator`
Estimates the output sparsity for a single matrix multiplication.

Specified by:
  `estim` in class `SparsityEstimator`
Parameters:
  `m1` - left-hand-side operand
  `m2` - right-hand-side operand
Returns:
  sparsity

### estim

public double estim(MatrixBlock m1, MatrixBlock m2, SparsityEstimator.OpCode op)
Description copied from class: `SparsityEstimator`
Estimates the output sparsity for a given binary operation.

Specified by:
  `estim` in class `SparsityEstimator`
Parameters:
  `m1` - left-hand-side operand
  `m2` - right-hand-side operand
  `op` - operator code
Returns:
  sparsity

### estim

public double estim(MatrixBlock m, SparsityEstimator.OpCode op)
Description copied from class: `SparsityEstimator`
Estimates the output sparsity for a given unary operation.

Specified by:
  `estim` in class `SparsityEstimator`
Parameters:
  `m` - left-hand-side operand
  `op` - operator code
Returns:
  sparsity